#include <iostream>
#define MAXN 30005
using namespace std;

int main()
{
    int t;
    cin>>t;
    for(int g=0;g<t;g++)
    {
        int n,indprvog,inddrugog,vrprvog,vrdrugog,razlikaind,razlikavr;
        int a[MAXN],b[MAXN];
        cin>>n;
        for(int i=1;i<=n;i++){
            cin>>a[i];
            if(a[i]!=0){
                vrprvog=a[i];
                indprvog=i;
            }
        }
        for(int i=1;i<=n;i++){
            cin>>b[i];
            if(b[i]!=0){
                vrdrugog=b[i];
                inddrugog=i;
            }
        }

        if(abs(vrprvog)!=abs(vrdrugog)) {
            cout<<"NE"<<endl;
        }
        else
        {
            if(indprvog>inddrugog)
                razlikaind=indprvog-inddrugog;
            if(inddrugog>indprvog)
                razlikaind=inddrugog-indprvog;
            if(inddrugog==indprvog)
                {
                    if(vrprvog!=vrdrugog){
                        cout<<"NE"<<endl;break;
                    }
                    else {
                        cout<<"DA"<<endl;break;
                    }
                }
            if(razlikaind%2!=0 && vrprvog==vrdrugog)
                cout<<"NE"<<endl;
            if(razlikaind%2!=0 && vrprvog!=vrdrugog)
                cout<<"DA"<<endl;
            if(razlikaind%2==0 && vrprvog==vrdrugog)
                cout<<"DA"<<endl;
            if(razlikaind%2==0 && vrprvog!=vrdrugog)
                cout<<"NE"<<endl;

        }
    }
    return 0;
}